/* Utils.c generated by valac 0.56.17, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2013 Mario Guerriero <mefrio.g@gmail.com>
*               2017 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "codecore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

gchar* scratch_utils_last_path = NULL;

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 53 "Utils.c"
}

GSimpleAction*
scratch_utils_action_from_group (const gchar* action_name,
                                 GSimpleActionGroup* action_group)
{
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* result;
#line 25 "../src/Utils.vala"
	g_return_val_if_fail (action_name != NULL, NULL);
#line 25 "../src/Utils.vala"
	g_return_val_if_fail (action_group != NULL, NULL);
#line 26 "../src/Utils.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, action_name);
#line 26 "../src/Utils.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 26 "../src/Utils.vala"
	result = _tmp1_;
#line 26 "../src/Utils.vala"
	return result;
#line 75 "Utils.c"
}

gchar*
scratch_utils_pango_font_description_to_css (PangoFontDescription* font_descr)
{
	GString* sb = NULL;
	GString* _tmp0_;
	PangoFontMask mask = 0U;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 32 "../src/Utils.vala"
	g_return_val_if_fail (font_descr != NULL, NULL);
#line 33 "../src/Utils.vala"
	_tmp0_ = g_string_new ("");
#line 33 "../src/Utils.vala"
	sb = _tmp0_;
#line 34 "../src/Utils.vala"
	mask = pango_font_description_get_set_fields (font_descr);
#line 35 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_FAMILY) == PANGO_FONT_MASK_FAMILY) {
#line 98 "Utils.c"
		const gchar* family = NULL;
		const gchar* _tmp1_;
		GString* _tmp2_;
		const gchar* _tmp3_;
#line 36 "../src/Utils.vala"
		_tmp1_ = pango_font_description_get_family (font_descr);
#line 36 "../src/Utils.vala"
		family = _tmp1_;
#line 37 "../src/Utils.vala"
		_tmp2_ = sb;
#line 37 "../src/Utils.vala"
		_tmp3_ = family;
#line 37 "../src/Utils.vala"
		g_string_append_printf (_tmp2_, "font-family: \"%s\";", _tmp3_);
#line 113 "Utils.c"
	}
#line 40 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_STYLE) == PANGO_FONT_MASK_STYLE) {
#line 117 "Utils.c"
		PangoStyle style = 0;
#line 41 "../src/Utils.vala"
		style = pango_font_description_get_style (font_descr);
#line 43 "../src/Utils.vala"
		switch (style) {
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_NORMAL:
#line 125 "Utils.c"
			{
				GString* _tmp4_;
#line 45 "../src/Utils.vala"
				_tmp4_ = sb;
#line 45 "../src/Utils.vala"
				g_string_append (_tmp4_, "font-style: normal;");
#line 46 "../src/Utils.vala"
				break;
#line 134 "Utils.c"
			}
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_ITALIC:
#line 138 "Utils.c"
			{
				GString* _tmp5_;
#line 49 "../src/Utils.vala"
				_tmp5_ = sb;
#line 49 "../src/Utils.vala"
				g_string_append (_tmp5_, "font-style: italic;");
#line 50 "../src/Utils.vala"
				break;
#line 147 "Utils.c"
			}
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_OBLIQUE:
#line 151 "Utils.c"
			{
				GString* _tmp6_;
#line 53 "../src/Utils.vala"
				_tmp6_ = sb;
#line 53 "../src/Utils.vala"
				g_string_append (_tmp6_, "font-style: bold;");
#line 54 "../src/Utils.vala"
				break;
#line 160 "Utils.c"
			}
			default:
			{
#line 57 "../src/Utils.vala"
				break;
#line 166 "Utils.c"
			}
		}
	}
#line 61 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_VARIANT) == PANGO_FONT_MASK_VARIANT) {
#line 172 "Utils.c"
		PangoVariant variant = 0;
#line 62 "../src/Utils.vala"
		variant = pango_font_description_get_variant (font_descr);
#line 63 "../src/Utils.vala"
		switch (variant) {
#line 63 "../src/Utils.vala"
			case PANGO_VARIANT_NORMAL:
#line 180 "Utils.c"
			{
				GString* _tmp7_;
#line 65 "../src/Utils.vala"
				_tmp7_ = sb;
#line 65 "../src/Utils.vala"
				g_string_append (_tmp7_, "font-variant: normal;");
#line 66 "../src/Utils.vala"
				break;
#line 189 "Utils.c"
			}
#line 63 "../src/Utils.vala"
			case PANGO_VARIANT_SMALL_CAPS:
#line 193 "Utils.c"
			{
				GString* _tmp8_;
#line 69 "../src/Utils.vala"
				_tmp8_ = sb;
#line 69 "../src/Utils.vala"
				g_string_append (_tmp8_, "font-variant: small-caps");
#line 70 "../src/Utils.vala"
				break;
#line 202 "Utils.c"
			}
			default:
			{
#line 73 "../src/Utils.vala"
				break;
#line 208 "Utils.c"
			}
		}
	}
#line 77 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_WEIGHT) == PANGO_FONT_MASK_WEIGHT) {
#line 214 "Utils.c"
		gint weight = 0;
		GString* _tmp9_;
#line 78 "../src/Utils.vala"
		weight = CLAMP ((gint) ((pango_font_description_get_weight (font_descr) / 100) * 100), 100, 900);
#line 80 "../src/Utils.vala"
		_tmp9_ = sb;
#line 80 "../src/Utils.vala"
		g_string_append_printf (_tmp9_, "font-weight: %i;", weight);
#line 223 "Utils.c"
	}
#line 83 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_STRETCH) == PANGO_FONT_MASK_STRETCH) {
#line 227 "Utils.c"
		PangoStretch stretch = 0;
#line 84 "../src/Utils.vala"
		stretch = pango_font_description_get_stretch (font_descr);
#line 86 "../src/Utils.vala"
		switch (stretch) {
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_NORMAL:
#line 235 "Utils.c"
			{
				GString* _tmp10_;
#line 88 "../src/Utils.vala"
				_tmp10_ = sb;
#line 88 "../src/Utils.vala"
				g_string_append_printf (_tmp10_, "font-stretch: %s;", "normal");
#line 89 "../src/Utils.vala"
				break;
#line 244 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_ULTRA_CONDENSED:
#line 248 "Utils.c"
			{
				GString* _tmp11_;
#line 92 "../src/Utils.vala"
				_tmp11_ = sb;
#line 92 "../src/Utils.vala"
				g_string_append_printf (_tmp11_, "font-stretch: %s;", "condensed");
#line 93 "../src/Utils.vala"
				break;
#line 257 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXTRA_CONDENSED:
#line 261 "Utils.c"
			{
				GString* _tmp12_;
#line 96 "../src/Utils.vala"
				_tmp12_ = sb;
#line 96 "../src/Utils.vala"
				g_string_append_printf (_tmp12_, "font-stretch: %s;", "extra-condensed");
#line 97 "../src/Utils.vala"
				break;
#line 270 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_CONDENSED:
#line 274 "Utils.c"
			{
				GString* _tmp13_;
#line 100 "../src/Utils.vala"
				_tmp13_ = sb;
#line 100 "../src/Utils.vala"
				g_string_append_printf (_tmp13_, "font-stretch: %s;", "condensed");
#line 101 "../src/Utils.vala"
				break;
#line 283 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_SEMI_CONDENSED:
#line 287 "Utils.c"
			{
				GString* _tmp14_;
#line 104 "../src/Utils.vala"
				_tmp14_ = sb;
#line 104 "../src/Utils.vala"
				g_string_append_printf (_tmp14_, "font-stretch: %s;", "normal");
#line 105 "../src/Utils.vala"
				break;
#line 296 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_SEMI_EXPANDED:
#line 300 "Utils.c"
			{
				GString* _tmp15_;
#line 108 "../src/Utils.vala"
				_tmp15_ = sb;
#line 108 "../src/Utils.vala"
				g_string_append_printf (_tmp15_, "font-stretch: %s;", "semi-expanded");
#line 109 "../src/Utils.vala"
				break;
#line 309 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXPANDED:
#line 313 "Utils.c"
			{
				GString* _tmp16_;
#line 112 "../src/Utils.vala"
				_tmp16_ = sb;
#line 112 "../src/Utils.vala"
				g_string_append_printf (_tmp16_, "font-stretch: %s;", "expanded");
#line 113 "../src/Utils.vala"
				break;
#line 322 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXTRA_EXPANDED:
#line 326 "Utils.c"
			{
				GString* _tmp17_;
#line 116 "../src/Utils.vala"
				_tmp17_ = sb;
#line 116 "../src/Utils.vala"
				g_string_append_printf (_tmp17_, "font-stretch: %s;", "extra-expanded");
#line 117 "../src/Utils.vala"
				break;
#line 335 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_ULTRA_EXPANDED:
#line 339 "Utils.c"
			{
				GString* _tmp18_;
#line 120 "../src/Utils.vala"
				_tmp18_ = sb;
#line 120 "../src/Utils.vala"
				g_string_append_printf (_tmp18_, "font-stretch: %s;", "ultra-expanded");
#line 121 "../src/Utils.vala"
				break;
#line 348 "Utils.c"
			}
			default:
			{
#line 124 "../src/Utils.vala"
				break;
#line 354 "Utils.c"
			}
		}
	}
#line 129 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_SIZE) == PANGO_FONT_MASK_SIZE) {
#line 360 "Utils.c"
		gint font_size = 0;
		GString* _tmp19_;
#line 130 "../src/Utils.vala"
		font_size = pango_font_description_get_size (font_descr) / PANGO_SCALE;
#line 131 "../src/Utils.vala"
		_tmp19_ = sb;
#line 131 "../src/Utils.vala"
		g_string_append_printf (_tmp19_, "font-size: %dpt;", font_size);
#line 369 "Utils.c"
	}
#line 134 "../src/Utils.vala"
	_tmp20_ = sb;
#line 134 "../src/Utils.vala"
	_tmp21_ = _tmp20_->str;
#line 134 "../src/Utils.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 134 "../src/Utils.vala"
	result = _tmp22_;
#line 134 "../src/Utils.vala"
	_g_string_free0 (sb);
#line 134 "../src/Utils.vala"
	return result;
#line 383 "Utils.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 406 "Utils.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 415 "Utils.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 434 "Utils.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 438 "Utils.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 444 "Utils.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 454 "Utils.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 462 "Utils.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 466 "Utils.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 472 "Utils.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 482 "Utils.c"
}

gchar*
scratch_utils_replace_home_with_tilde (const gchar* path)
{
	gchar* home_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* result;
#line 137 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 138 "../src/Utils.vala"
	_tmp0_ = g_get_home_dir ();
#line 138 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 138 "../src/Utils.vala"
	home_dir = _tmp1_;
#line 139 "../src/Utils.vala"
	_tmp2_ = home_dir;
#line 139 "../src/Utils.vala"
	if (g_str_has_prefix (path, _tmp2_)) {
#line 505 "Utils.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 140 "../src/Utils.vala"
		_tmp3_ = home_dir;
#line 140 "../src/Utils.vala"
		_tmp4_ = strlen (_tmp3_);
#line 140 "../src/Utils.vala"
		_tmp5_ = _tmp4_;
#line 140 "../src/Utils.vala"
		_tmp6_ = string_substring (path, (glong) _tmp5_, (glong) -1);
#line 140 "../src/Utils.vala"
		_tmp7_ = _tmp6_;
#line 140 "../src/Utils.vala"
		_tmp8_ = g_strconcat ("~", _tmp7_, NULL);
#line 140 "../src/Utils.vala"
		_tmp9_ = _tmp8_;
#line 140 "../src/Utils.vala"
		_g_free0 (_tmp7_);
#line 140 "../src/Utils.vala"
		result = _tmp9_;
#line 140 "../src/Utils.vala"
		_g_free0 (home_dir);
#line 140 "../src/Utils.vala"
		return result;
#line 535 "Utils.c"
	} else {
		gchar* _tmp10_;
#line 142 "../src/Utils.vala"
		_tmp10_ = g_strdup (path);
#line 142 "../src/Utils.vala"
		result = _tmp10_;
#line 142 "../src/Utils.vala"
		_g_free0 (home_dir);
#line 142 "../src/Utils.vala"
		return result;
#line 546 "Utils.c"
	}
}

gboolean
scratch_utils_find_unique_path (GFile* f1,
                                GFile* f2,
                                gchar** path1,
                                gchar** path2)
{
	gchar* _vala_path1 = NULL;
	gchar* _vala_path2 = NULL;
	GFile* f1_parent = NULL;
	GFile* _tmp0_;
	GFile* f2_parent = NULL;
	GFile* _tmp1_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gboolean result;
#line 146 "../src/Utils.vala"
	g_return_val_if_fail (f1 != NULL, FALSE);
#line 146 "../src/Utils.vala"
	g_return_val_if_fail (f2 != NULL, FALSE);
#line 147 "../src/Utils.vala"
	if (g_file_equal (f1, f2)) {
#line 148 "../src/Utils.vala"
		_g_free0 (_vala_path1);
#line 148 "../src/Utils.vala"
		_vala_path1 = NULL;
#line 149 "../src/Utils.vala"
		_g_free0 (_vala_path2);
#line 149 "../src/Utils.vala"
		_vala_path2 = NULL;
#line 150 "../src/Utils.vala"
		result = FALSE;
#line 150 "../src/Utils.vala"
		if (path1) {
#line 150 "../src/Utils.vala"
			*path1 = _vala_path1;
#line 587 "Utils.c"
		} else {
#line 150 "../src/Utils.vala"
			_g_free0 (_vala_path1);
#line 591 "Utils.c"
		}
#line 150 "../src/Utils.vala"
		if (path2) {
#line 150 "../src/Utils.vala"
			*path2 = _vala_path2;
#line 597 "Utils.c"
		} else {
#line 150 "../src/Utils.vala"
			_g_free0 (_vala_path2);
#line 601 "Utils.c"
		}
#line 150 "../src/Utils.vala"
		return result;
#line 605 "Utils.c"
	}
#line 153 "../src/Utils.vala"
	_tmp0_ = g_file_get_parent (f1);
#line 153 "../src/Utils.vala"
	f1_parent = _tmp0_;
#line 154 "../src/Utils.vala"
	_tmp1_ = g_file_get_parent (f2);
#line 154 "../src/Utils.vala"
	f2_parent = _tmp1_;
#line 156 "../src/Utils.vala"
	while (TRUE) {
#line 617 "Utils.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
#line 156 "../src/Utils.vala"
		_tmp2_ = f1_parent;
#line 156 "../src/Utils.vala"
		_tmp3_ = g_file_get_relative_path (_tmp2_, f1);
#line 156 "../src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 156 "../src/Utils.vala"
		_tmp5_ = f2_parent;
#line 156 "../src/Utils.vala"
		_tmp6_ = g_file_get_relative_path (_tmp5_, f2);
#line 156 "../src/Utils.vala"
		_tmp7_ = _tmp6_;
#line 156 "../src/Utils.vala"
		_tmp8_ = !(g_strcmp0 (_tmp4_, _tmp7_) == 0);
#line 156 "../src/Utils.vala"
		_g_free0 (_tmp7_);
#line 156 "../src/Utils.vala"
		_g_free0 (_tmp4_);
#line 156 "../src/Utils.vala"
		if (_tmp8_) {
#line 156 "../src/Utils.vala"
			break;
#line 651 "Utils.c"
		}
#line 157 "../src/Utils.vala"
		_tmp9_ = f1_parent;
#line 157 "../src/Utils.vala"
		_tmp10_ = g_file_get_parent (_tmp9_);
#line 157 "../src/Utils.vala"
		_g_object_unref0 (f1_parent);
#line 157 "../src/Utils.vala"
		f1_parent = _tmp10_;
#line 158 "../src/Utils.vala"
		_tmp11_ = f2_parent;
#line 158 "../src/Utils.vala"
		_tmp12_ = g_file_get_parent (_tmp11_);
#line 158 "../src/Utils.vala"
		_g_object_unref0 (f2_parent);
#line 158 "../src/Utils.vala"
		f2_parent = _tmp12_;
#line 669 "Utils.c"
	}
#line 161 "../src/Utils.vala"
	_tmp13_ = f1_parent;
#line 161 "../src/Utils.vala"
	_tmp14_ = g_file_get_relative_path (_tmp13_, f1);
#line 161 "../src/Utils.vala"
	_g_free0 (_vala_path1);
#line 161 "../src/Utils.vala"
	_vala_path1 = _tmp14_;
#line 162 "../src/Utils.vala"
	_tmp15_ = f2_parent;
#line 162 "../src/Utils.vala"
	_tmp16_ = g_file_get_relative_path (_tmp15_, f2);
#line 162 "../src/Utils.vala"
	_g_free0 (_vala_path2);
#line 162 "../src/Utils.vala"
	_vala_path2 = _tmp16_;
#line 163 "../src/Utils.vala"
	result = TRUE;
#line 163 "../src/Utils.vala"
	_g_object_unref0 (f2_parent);
#line 163 "../src/Utils.vala"
	_g_object_unref0 (f1_parent);
#line 163 "../src/Utils.vala"
	if (path1) {
#line 163 "../src/Utils.vala"
		*path1 = _vala_path1;
#line 697 "Utils.c"
	} else {
#line 163 "../src/Utils.vala"
		_g_free0 (_vala_path1);
#line 701 "Utils.c"
	}
#line 163 "../src/Utils.vala"
	if (path2) {
#line 163 "../src/Utils.vala"
		*path2 = _vala_path2;
#line 707 "Utils.c"
	} else {
#line 163 "../src/Utils.vala"
		_g_free0 (_vala_path2);
#line 711 "Utils.c"
	}
#line 163 "../src/Utils.vala"
	return result;
#line 715 "Utils.c"
}

gboolean
scratch_utils_check_if_valid_text_file (const gchar* path,
                                        GFileInfo* info)
{
	gchar* content_type = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 166 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 166 "../src/Utils.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 167 "../src/Utils.vala"
	if (g_str_has_prefix (path, ".goutputstream")) {
#line 168 "../src/Utils.vala"
		result = FALSE;
#line 168 "../src/Utils.vala"
		return result;
#line 738 "Utils.c"
	}
#line 171 "../src/Utils.vala"
	if (g_file_info_get_is_backup (info)) {
#line 172 "../src/Utils.vala"
		result = FALSE;
#line 172 "../src/Utils.vala"
		return result;
#line 746 "Utils.c"
	}
#line 175 "../src/Utils.vala"
	_tmp0_ = g_file_info_get_content_type (info);
#line 175 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 175 "../src/Utils.vala"
	content_type = _tmp1_;
#line 176 "../src/Utils.vala"
	if (g_file_info_get_file_type (info) == G_FILE_TYPE_REGULAR) {
#line 756 "Utils.c"
		const gchar* _tmp4_;
#line 177 "../src/Utils.vala"
		_tmp4_ = content_type;
#line 177 "../src/Utils.vala"
		_tmp3_ = g_content_type_is_a (_tmp4_, "text/*");
#line 762 "Utils.c"
	} else {
#line 176 "../src/Utils.vala"
		_tmp3_ = FALSE;
#line 766 "Utils.c"
	}
#line 176 "../src/Utils.vala"
	if (_tmp3_) {
#line 176 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 772 "Utils.c"
	} else {
		const gchar* _tmp5_;
#line 178 "../src/Utils.vala"
		_tmp5_ = content_type;
#line 178 "../src/Utils.vala"
		_tmp2_ = g_content_type_is_a (_tmp5_, "application/x-zerosize");
#line 779 "Utils.c"
	}
#line 176 "../src/Utils.vala"
	if (_tmp2_) {
#line 181 "../src/Utils.vala"
		result = TRUE;
#line 181 "../src/Utils.vala"
		_g_free0 (content_type);
#line 181 "../src/Utils.vala"
		return result;
#line 789 "Utils.c"
	}
#line 184 "../src/Utils.vala"
	result = FALSE;
#line 184 "../src/Utils.vala"
	_g_free0 (content_type);
#line 184 "../src/Utils.vala"
	return result;
#line 797 "Utils.c"
}

